/* This source is placed in the public domain.  Do what you want with it */



#include <termios.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
/* all those includes are for the serial port buffer check defs */
extern main();
extern unsigned char portdata[10000];

readport(int fdSer) {
   int n,E;
   n = 0;
   while (n != 2001) {
	portdata[n] = *" ";
	n = n + 1;
   }
   n = 0;
   E = buffer_wait(fdSer);
   while (E == 1) {
/*        printf("%d\n",buffer_wait(fdSer));  */
	read(fdSer,&portdata[n],1);
	printf("%c",portdata[n]);
	n = n + 1;
	E = buffer_wait(fdSer);
   }
   printf("\n");
}



/* You can use a function like this. It returns 1 if data is waiting or 0
 * if not.
 * Thanks to Michael 'Ghandi' Herold.
 */

int buffer_wait(int fdSer)
{
   struct timeval timeout;

   fd_set   fds;
   int      result;

   FD_ZERO(&fds);
   FD_SET(fdSer, &fds);

   timeout.tv_sec    = 1;  /* waits for char a max of 1 second */
   timeout.tv_usec   = 0;
   result = select(FD_SETSIZE , &fds, NULL, NULL, &timeout);
   if (result > 0) return(1);

   return(0);
}
